.686
.model flat, c
option casemap:none

.data?
crcTable	dd	256 dup(?)

.code
crcInit proc
	push esi
	push edi
	
	mov ecx, 255
_loop:
	mov edx, 8
	mov eax, ecx
_loop2:
	shr eax, 1
	jnc _cont2
	xor eax, 0EDB88320h
_cont2:
	sub edx, 1
	jnz _loop2
	
	mov crcTable[4*ecx], eax
	
	sub ecx, 1
	jnc _loop
	
	mov eax, 0
	pop edi
	pop esi
	ret
crcInit endp

crcCalc proc _data:dword, _length:dword
	push esi
	push edi
	
	mov esi, _data
	
	mov eax, 0FFFFFFFFh
	
	mov ecx, 0
_loop:
	movzx edx, byte ptr [esi+ecx]
	xor edx, eax
	and edx, 0FFh
	mov edx, crcTable[4*edx]
	
	shr eax, 8
	xor eax, edx
	
	add ecx, 1
	cmp ecx, _length
	jnz _loop
	
	xor eax, 0FFFFFFFFh
	pop edi
	pop esi
	ret
crcCalc endp

end